import dbm
import os
import tkinter as tk
from tkinter import simpledialog
import http.client
from datetime import datetime, timedelta
from cryptography.fernet import Fernet


def fuel(key):
    root = tk.Tk()
    root.withdraw()

    def input_v():
        user_input = simpledialog.askstring("请联系电话：13838018772!", "Please enter the key:", parent=root)
        if user_input:
            with dbm.open(key_path, 'c') as db:
                db['key'] = user_input
                print(db['key'])

    def bd_time(end):
        conn = http.client.HTTPConnection("www.baidu.com")
        conn.request("GET", "/")
        date = conn.getresponse().getheader('date')
        ts = datetime.strptime(date, "%a, %d %b %Y %H:%M:%S GMT") + timedelta(hours=8)
        return int(end) - int(ts.timestamp())

    def decrypt_data(encrypted_data):
        """使用给定的密钥解密数据"""
        cipher_suite = Fernet(key)
        decrypted_data = cipher_suite.decrypt(encrypted_data)
        return decrypted_data.decode()

    def get_cache_path(filename):
        """获取当前用户的桌面路径，并拼接文件名"""
        return os.path.join(os.path.expandvars('%LOCALAPPDATA%'), filename)

    db_name = key.decode('utf-8')[:19]
    key_path = get_cache_path(db_name)

    try:
        with dbm.open(key_path, 'c') as db:
            k = decrypt_data(encrypted_data=db['key'])
            v = bd_time(k)
            if v > 0:
                return v
            else:
                input_v()
    except:
        input_v()

    finally:
        root.destroy()
